$use "pprtr32.lib"

DECLARE IMPORT,DefPrtr(newone:String,oldone:String),INT
DECLARE IMPORT,GetPort(ptrport:String),INT
DECLARE IMPORT,GetPrtr(DefPrtr:String),INT
DECLARE IMPORT,PPGetDriver(sdriver:String),INT
DECLARE IMPORT,PPGetSizes(lPaperX:INT,lPaperY:INT,lPageX:INT,lPageY:INT,lPageLeft:INT,lPageTop:INT,lPixInX:INT,lPixInY:INT),INT
DECLARE IMPORT,PPRemoveFileName(s1:String,fn:String),INT
DECLARE IMPORT,PPResetDC(hWndx:INT,hDCx:INT),INT
DECLARE IMPORT,PPrtr(hx:INT,i1:INT,i2:INT,i3:INT),INT
DECLARE IMPORT,PPSetupFileName(s1:String,fn:String),INT
DECLARE IMPORT,PrtrCap(nDC:DEVCAP),INT
DECLARE IMPORT,Prtrs(plist:String),INT
DECLARE IMPORT,SetuPP(hWndx:INT),INT

' Field selection bits
CONST DM_ORIENTATION = 0x1
CONST DM_PAPERSIZE = 0x2
CONST DM_PAPERLENGTH = 0x4
CONST DM_PAPERWIDTH = 0x8
CONST DM_SCALE = 0x10
CONST DM_COPIES = 0x100
CONST DM_DEFAULTSOURCE = 0x200
CONST DM_PRINTQUALITY = 0x400
CONST DM_COLOR = 0x800
CONST DM_DUPLEX = 0x1000
CONST DM_YRESOLUTION = 0x2000
CONST DM_TTOPTION = 0x4000
CONST DM_COLLATE = 0x8000
CONST DM_FORMNAME = 0x10000
CONST DM_LOGPIXELS = 0x20000
CONST DM_BITSPERPEL = 0x40000
CONST DM_PELSWIDTH = 0x80000
CONST DM_PELSHEIGHT = 0x100000
CONST DM_DISPLAYFLAGS = 0x200000
CONST DM_DISPLAYFREQUENCY = 0x400000
CONST DM_ICMMETHOD = 0x800000
CONST DM_ICMINTENT = 0x1000000
CONST DM_MEDIATYPE = 0x2000000
CONST DM_DITHERTYPE = 0x4000000

' Orientation selections
CONST DMORIENT_PORTRAIT = 1
CONST DMORIENT_LANDSCAPE = 2

' Paper selections
CONST DMPAPER_LETTER = 1                   ' Letter 8 1/2 x 11 in
CONST DMPAPER_LETTERSMALL = 2              ' Letter Small 8 1/2 x 11 in
CONST DMPAPER_TABLOID = 3                  ' Tabloid 11 x 17 in
CONST DMPAPER_LEDGER = 4                   ' Ledger 17 x 11 in
CONST DMPAPER_LEGAL = 5                    ' Legal 8 1/2 x 14 in
CONST DMPAPER_STATEMENT = 6                ' Statement 5 1/2 x 8 1/2 in
CONST DMPAPER_EXECUTIVE = 7                ' Executive 7 1/4 x 10 1/2 in
CONST DMPAPER_A3 = 8                       ' A3 297 x 420 mm
CONST DMPAPER_A4 = 9                       ' A4 210 x 297 mm
CONST DMPAPER_A4SMALL = 10                 ' A4 Small 210 x 297 mm
CONST DMPAPER_A5 = 11                      ' A5 148 x 210 mm
CONST DMPAPER_B4 = 12                      ' B4 (JIS) 250 x 354
CONST DMPAPER_B5 = 13                      ' B5 (JIS) 182 x 257 mm
CONST DMPAPER_FOLIO = 14                   ' Folio 8 1/2 x 13 in
CONST DMPAPER_QUARTO = 15                  ' Quarto 215 x 275 mm
CONST DMPAPER_11X14 = 16                   ' 10x14 in
CONST DMPAPER_11X17 = 17                   ' 11x17 in
CONST DMPAPER_NOTE = 18                    ' Note 8 1/2 x 11 in
CONST DMPAPER_ENV_9 = 19                   ' Envelope #9 3 7/8 x 8 7/8
CONST DMPAPER_ENV_10 = 20                  ' Envelope #10 4 1/8 x 9 1/2
CONST DMPAPER_ENV_11 = 21                  ' Envelope #11 4 1/2 x 10 3/8
CONST DMPAPER_ENV_12 = 22                  ' Envelope #12 4 \276 x 11
CONST DMPAPER_ENV_14 = 23                  ' Envelope #14 5 x 11 1/2
CONST DMPAPER_CSHEET = 24                  ' C size sheet
CONST DMPAPER_DSHEET = 25                  ' D size sheet
CONST DMPAPER_ESHEET = 26                  ' E size sheet
CONST DMPAPER_ENV_DL = 27                  ' Envelope DL 110 x 220mm
CONST DMPAPER_ENV_C5 = 28                  ' Envelope C5 162 x 229 mm
CONST DMPAPER_ENV_C3 = 29                  ' Envelope C3  324 x 458 mm
CONST DMPAPER_ENV_C4 = 30                  ' Envelope C4  229 x 324 mm
CONST DMPAPER_ENV_C6 = 31                  ' Envelope C6  114 x 162 mm
CONST DMPAPER_ENV_C65 = 32                 ' Envelope C65 114 x 229 mm
CONST DMPAPER_ENV_B4 = 33                  ' Envelope B4  250 x 353 mm
CONST DMPAPER_ENV_B5 = 34                  ' Envelope B5  176 x 250 mm
CONST DMPAPER_ENV_B6 = 35                  ' Envelope B6  176 x 125 mm
CONST DMPAPER_ENV_ITALY = 36               ' Envelope 110 x 230 mm
CONST DMPAPER_ENV_MONARCH = 37             ' Envelope Monarch 3.875 x 7.5 in
CONST DMPAPER_ENV_PERSONAL = 38            ' 6 3/4 Envelope 3 5/8 x 6 1/2 in
CONST DMPAPER_FANFOLD_US = 39              ' US Std Fanfold 14 7/8 x 11 in
CONST DMPAPER_FANFOLD_STD_GERMAN = 40      ' German Std Fanfold 8 1/2 x 12 in
CONST DMPAPER_FANFOLD_LGL_GERMAN = 41      ' German Legal Fanfold 8 1/2 x 13 in
CONST DMPAPER_ISO_B4 = 42                  ' B4 (ISO) 250 x 353 mm
CONST DMPAPER_JAPANESE_POSTCARD = 43       ' Japanese Postcard 100 x 148 mm
CONST DMPAPER_9X11 = 44                    ' 9 x 11 in
CONST DMPAPER_11X11 = 45                   ' 10 x 11 in
CONST DMPAPER_15X11 = 46                   ' 15 x 11 in
CONST DMPAPER_ENV_INVITE = 47              ' Envelope Invite 220 x 220 mm
CONST DMPAPER_RESERVED_48 = 48             ' RESERVED--DO NOT USE
CONST DMPAPER_RESERVED_49 = 49             ' RESERVED--DO NOT USE
CONST DMPAPER_LETTER_EXTRA = 50            ' Letter Extra 9 \275 x 12 in
CONST DMPAPER_LEGAL_EXTRA = 51             ' Legal Extra 9 \275 x 15 in
CONST DMPAPER_TABLOID_EXTRA = 52           ' Tabloid Extra 11.69 x 18 in
CONST DMPAPER_A4_EXTRA = 53                ' A4 Extra 9.27 x 12.69 in
CONST DMPAPER_LETTER_TRANSVERSE = 54       ' Letter Transverse 8 \275 x 11 in
CONST DMPAPER_A4_TRANSVERSE = 55           ' A4 Transverse 210 x 297 mm
CONST DMPAPER_LETTER_EXTRA_TRANSVERSE = 56 ' Letter Extra Transverse 9\275 x 12 in
CONST DMPAPER_A_PLUS = 57                  ' SuperA/SuperA/A4 227 x 356 mm
CONST DMPAPER_B_PLUS = 58                  ' SuperB/SuperB/A3 305 x 487 mm
CONST DMPAPER_LETTER_PLUS = 59             ' Letter Plus 8.5 x 12.69 in
CONST DMPAPER_A4_PLUS = 60                 ' A4 Plus 210 x 330 mm
CONST DMPAPER_A5_TRANSVERSE = 61           ' A5 Transverse 148 x 210 mm
CONST DMPAPER_B5_TRANSVERSE = 62           ' B5 (JIS) Transverse 182 x 257 mm
CONST DMPAPER_A3_EXTRA = 63                ' A3 Extra 322 x 445 mm
CONST DMPAPER_A5_EXTRA = 64                ' A5 Extra 174 x 235 mm
CONST DMPAPER_B5_EXTRA = 65                ' B5 (ISO) Extra 201 x 276 mm
CONST DMPAPER_A2 = 66                      ' A2 420 x 594 mm
CONST DMPAPER_A3_TRANSVERSE = 67           ' A3 Transverse 297 x 420 mm
CONST DMPAPER_A3_EXTRA_TRANSVERSE = 68     ' A3 Extra Transverse 322 x 445 mm

CONST DMPAPER_USER = 256

' Bin selections
CONST DMBIN_UPPER = 1
CONST DMBIN_ONLYONE = 1
CONST DMBIN_LOWER = 2
CONST DMBIN_MIDDLE = 3
CONST DMBIN_MANUAL = 4
CONST DMBIN_ENVELOPE = 5
CONST DMBIN_ENVMANUAL = 6
CONST DMBIN_AUTO = 7
CONST DMBIN_TRACTOR = 8
CONST DMBIN_SMALLFMT = 9
CONST DMBIN_LARGEFMT = 10
CONST DMBIN_LARGECAPACITY = 11
CONST DMBIN_CASSETTE = 14
CONST DMBIN_FORMSOURCE = 15
CONST DMBIN_USER = 256                 ' device specific bins start here

' Print qualities
CONST DMRES_DRAFT = (-1)
CONST DMRES_LOW = (-2)
CONST DMRES_MEDIUM = (-3)
CONST DMRES_HIGH = (-4)

' Color enable/disable for color printers
CONST DMCOLOR_MONOCHROME = 1
CONST DMCOLOR_COLOR = 2

' Duplex enable
CONST DMDUP_SIMPLEX = 1
CONST DMDUP_VERTICAL = 2
CONST DMDUP_HORIZONTAL = 3

' TrueType options
CONST DMTT_BITMAP = 1              ' print TT fonts as graphics
CONST DMTT_DOWNLOAD = 2            ' download TT fonts as soft fonts
CONST DMTT_SUBDEV = 3              ' substitute device fonts for TT fonts
CONST DMTT_DOWNLOAD_OUTLINE = 4    ' download TT fonts as outline soft fonts

' Collation selections
CONST DMCOLLATE_FALSE = 0
CONST DMCOLLATE_TRUE = 1

' DEVMODE dmDisplayFlags flags

CONST DM_GRAYSCALE = 0x1
CONST DM_INTERLACED = 0x2

' ICM methods
CONST DMICMMETHOD_NONE = 1         ' ICM disabled
CONST DMICMMETHOD_SYSTEM = 2       ' ICM handled by system
CONST DMICMMETHOD_DRIVER = 3       ' ICM handled by driver
CONST DMICMMETHOD_DEVICE = 4       ' ICM handled by device
CONST DMICMMETHOD_USER = 256       ' Device-specific methods start here

' ICM Intents
CONST DMICM_SATURATE = 1           ' Maximize color saturation
CONST DMICM_CONTRAST = 2           ' Maximize color contrast
CONST DMICM_COLORMETRIC = 3        ' Use specific color metric
CONST DMICM_USER = 256             ' Device-specific intents start here

' Media types
CONST DMMEDIA_STANDARD = 1           ' Standard paper
CONST DMMEDIA_TRANSPARENCY = 2       ' Transparency
CONST DMMEDIA_GLOSSY = 3             ' Glossy paper
CONST DMMEDIA_USER = 256             ' Device-specific media start here

' Dither types
CONST DMDITHER_NONE = 1          ' No dithering
CONST DMDITHER_COARSE = 2        ' Dither with a coarse brush
CONST DMDITHER_FINE = 3          ' Dither with a fine brush
CONST DMDITHER_LINEART = 4       ' LineArt dithering
CONST DMDITHER_ERRORDIFFUSION = 5    ' LineArt dithering
CONST DMDITHER_RESERVED6 = 6         ' LineArt dithering
CONST DMDITHER_RESERVED7 = 7         ' LineArt dithering
CONST DMDITHER_RESERVED8 = 8         ' LineArt dithering
CONST DMDITHER_RESERVED9 = 9         ' LineArt dithering
CONST DMDITHER_GRAYSCALE = 10          ' Device does grayscaling
CONST DMDITHER_USER = 256          ' Device-specific dithers start here

CONST PP_GIMME = 0
CONST PP_CHANGE_IT = 1
CONST PP_UNNEEDED = 0

'================ device capabilities ================
TYPE DEVCAP
      INT DRIVERVERSION
      INT TECHNOLOGY 'bits
      INT HORZSIZE
      INT VERTSIZE
      INT HORZRES
      INT VERTRES
      INT BITSPIXEL
      INT PLANES
      INT NUMBRUSHES
      INT NUMPENS
      INT NUMMARKERS
      INT NUMFONTS
      INT NUMCOLORS
      INT PDEVICESIZE
      INT CURVECAPS    ' bits
      INT LINECAPS    ' bits
      INT POLYGONALCAPS    ' bits
      INT TEXTCAPS    ' bits
      INT CLIPCAPS    ' bits
      INT RASTERCAPS    ' bits
      INT ASPECTX
      INT ASPECTY
      INT ASPECTXY
      INT LOGPIXELSX
      INT LOGPIXELSY
      INT SIZEPALETTE
      INT NUMRESERVED
      INT COLORRES
      INT PHYSICALWIDTH
      INT PHYSICALHEIGHT
      INT PHYSICALOFFSETX
      INT PHYSICALOFFSETY
      INT SCALINGFACTORX
      INT SCALINGFACTORY
ENDTYPE
	DEVCAP dc

'---- return value masks ---
' TECHNOLOGY
CONST DT_PLOTTER = 0
CONST DT_RASDISPLAY = 1
CONST DT_RASPRINTER = 2
CONST DT_RASCAMERA = 3
CONST DT_CHARSTREAM = 4
CONST DT_METAFILE = 5
CONST DT_DISPFILE = 6

' CURVECAPS
CONST CC_NONE = 0x0
CONST CC_CIRCLES = 0x1
CONST CC_PIE = 0x2
CONST CC_CHORD = 0x4
CONST CC_ELLIPSES = 0x8
CONST CC_WIDE = 0x10
CONST CC_STYLED = 0x20
CONST CC_WIDESTYLED = 0x40
CONST CC_INTERIORS = 0x80
CONST CC_ROUNDRECT = 0x100

' LINECAPS
CONST LC_NONE = 0x0
CONST LC_POLYLINE = 0x2
CONST LC_MARKER = 0x4
CONST LC_POLYMARKER = 0x8
CONST LC_WIDE = 0x10
CONST LC_STYLED = 0x20
CONST LC_WIDESTYLED = 0x40
CONST LC_INTERIORS = 0x80

' POLYGONALCAPS
CONST PC_NONE = 0x0
CONST PC_POLYGON = 0x1
CONST PC_RECTANGLE = 0x2
CONST PC_WINDPOLYGON = 0x4
CONST PC_SCANLINE = 0x8
CONST PC_WIDE = 0x10
CONST PC_STYLED = 0x20
CONST PC_WIDESTYLED = 0x40
CONST PC_INTERIORS = 0x80

' TEXTCAPS
CONST TC_NONE = 0x0
CONST TC_OP_CHARACTER = 0x1
CONST TC_OP_STROKE = 0x2
CONST TC_CP_STROKE = 0x4
CONST TC_CR_90 = 0x8
CONST TC_CR_ANY = 0x10
CONST TC_SF_X_YINDEP = 0x20
CONST TC_SA_DOUBLE = 0x40
CONST TC_SA_INTEGER = 0x80
CONST TC_SA_CONTIN = 0x100
CONST TC_EA_DOUBLE = 0x200
CONST TC_IA_ABLE = 0x400
CONST TC_UA_ABLE = 0x800
CONST TC_SO_ABLE = 0x1000
CONST TC_RA_ABLE = 0x2000
CONST TC_VA_ABLE = 0x4000
CONST TC_RESERVED = 0x8000

' CLIPCAPS
CONST CP_NONE = 0x0
CONST CP_RECTANGLE = 0x1
CONST CP_REGION = 0x2

' RASTERCAPS
CONST RC_NONE = 0x0
CONST RC_BITBLT = 0x1
CONST RC_BANDING = 0x2
CONST RC_SCALING = 0x4
CONST RC_BITMAP64 = 0x8
CONST RC_GDI20_OUTPUT = 0x10
CONST RC_GDI20_STATE = 0x20
CONST RC_SAVEBITMAP = 0x40
CONST RC_DI_BITMAP = 0x80
CONST RC_PALETTE = 0x100
CONST RC_DIBTODEV = 0x200
CONST RC_BIGFONT = 0x400
CONST RC_STRETCHBLT = 0x800
CONST RC_FLOODFILL = 0x1000
CONST RC_STRETCHDIB = 0x2000
CONST RC_OP_DX_OUTPUT = 0x4000
CONST RC_DEVBITS = 0x8000
